"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
const Node_1 = require("./types/Node");
const parser_1 = require("./parser");
const parseText = text => {
    const children = [];
    let textBuffer = '';
    const flush = () => {
        if (!textBuffer) {
            return;
        }
        children.push({
            type: Node_1.NodeType.Text,
            text: textBuffer
        });
        textBuffer = '';
    };
    let i = 0;
    const l = text.length;
    while (i < l) {
        const match = parser_1.default(text, i, parseText);
        if (match) {
            flush();
            const [node, position] = match;
            children.push(node);
            i = position;
            continue;
        }
        textBuffer += text.charAt(i);
        i += 1;
    }
    flush();
    return children;
};
exports.parse = (message) => {
    return {
        type: Node_1.NodeType.Root,
        children: parseText(message)
    };
};
exports.default = exports.parse;
__export(require("./types/Node"));
//# sourceMappingURL=index.js.map